## gcompris-qt 25.1.1+p24.04+vstable+git20251031.0735

=== debian/changelog ===
gcompris-qt (25.1.1+p24.04+vstable+git20251031.0735-0) noble; urgency=medium

  * Automatic Ubuntu CI Build

 -- Neon CI <neon@kde.org>  Fri, 31 Oct 2025 07:35:36 +0000
