=== debian/changelog ===
gcompris-qt (25.1.1+p24.04+vstable+git20251217.0050-0) noble; urgency=medium

  * Automatic Ubuntu CI Build

 -- Neon CI <neon@kde.org>  Wed, 17 Dec 2025 00:50:45 +0000
