## gcompris-qt 25.1.1+p24.04+vstable+git20251222.0222

=== debian/changelog ===
gcompris-qt (25.1.1+p24.04+vstable+git20251222.0222-0) noble; urgency=medium

  * Automatic Ubuntu CI Build

 -- Neon CI <neon@kde.org>  Mon, 22 Dec 2025 02:23:32 +0000
