## gcompris-qt 25.1.1+p24.04+vunstable+git20260105.1244

=== debian/changelog ===
gcompris-qt (25.1.1+p24.04+vunstable+git20260105.1244-0) noble; urgency=medium

  * Automatic Ubuntu CI Build

 -- Neon CI <neon@kde.org>  Mon, 05 Jan 2026 12:44:59 +0000
