## gcompris-qt 25.1.1+p24.04+vunstable+git20260129.0313

=== debian/changelog ===
gcompris-qt (25.1.1+p24.04+vunstable+git20260129.0313-0) noble; urgency=medium

  * Automatic Ubuntu CI Build

 -- Neon CI <neon@kde.org>  Thu, 29 Jan 2026 03:13:36 +0000
