=== debian/changelog ===
gcompris-qt (25.1.1+p24.04+vunstable+git20260201.0633-0) noble; urgency=medium

  * Automatic Ubuntu CI Build

 -- Neon CI <neon@kde.org>  Sun, 01 Feb 2026 06:33:10 +0000
